---
title: <clipPath>
slug: Web/SVG/Element/clipPath
tags:
  - Element
  - Reference
  - SVG
---
<div>{{SVGRef}}</div>

<p>The <strong><code>&lt;clipPath&gt;</code></strong> <a href="/en-US/docs/Web/SVG">SVG</a> element defines a clipping path, to be used by the {{SVGAttr("clip-path")}} property.</p>

<p>A clipping path restricts the region to which paint can be applied. Conceptually, parts of the drawing that lie outside of the region bounded by the clipping path are not drawn.</p>

<div id="Example">
<div class="hidden">
<pre class="brush: css">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html">&lt;svg viewBox="0 0 100 100"&gt;
  &lt;clipPath id="myClip"&gt;
    &lt;!--
      Everything outside the circle will be
      clipped and therefore invisible.
    --&gt;
    &lt;circle cx="40" cy="35" r="35" /&gt;
  &lt;/clipPath&gt;

  &lt;!-- The original black heart, for reference --&gt;
  &lt;path id="heart" d="M10,30 A20,20,0,0,1,50,30 A20,20,0,0,1,90,30 Q90,60,50,90 Q10,60,10,30 Z" /&gt;

  &lt;!--
    Only the portion of the red heart
    inside the clip circle is visible.
  --&gt;
  &lt;use clip-path="url(#myClip)" xlink:href="#heart" fill="red" /&gt;
&lt;/svg&gt;</pre>

<pre class="brush: css">/* With a touch of CSS for browsers who *
 * implemented the r Geometry Property. */

@keyframes openYourHeart {from {r: 0} to {r: 60px}}

#myClip circle {
  animation: openYourHeart 15s infinite;
}</pre>

<p>{{EmbedLiveSample('Example', 100, 100)}}</p>
</div>

<p>A clipping path is conceptually equivalent to a custom viewport for the referencing element. Thus, it affects the <em>rendering</em> of an element, but not the element's <em>inherent geometry</em>. The bounding box of a clipped element (meaning, an element which references a <code>&lt;clipPath&gt;</code> element via a {{SVGAttr("clip-path")}} property, or a child of the referencing element) must remain the same as if it were not clipped.</p>

<p>By default, {{cssxref("pointer-events")}} are not dispatched on clipped regions. For example, a circle with a radius of <code>10</code> which is clipped to a circle with a radius of <code>5</code> will not receive "click" events outside the smaller radius.</p>

<h2 id="Attributes">Attributes</h2>

<dl>
 <dt>{{SVGAttr("clipPathUnits")}}</dt>
 <dd>Defines the coordinate system for the contents of the <code>&lt;clipPath&gt;</code> element.<br>
 <small><em>Value type</em>: <code>userSpaceOnUse</code>|<code>objectBoundingBox</code> ; <em>Default value</em>: <code>userSpaceOnUse</code>; <em>Animatable</em>: <strong>yes</strong></small></dd>
</dl>

<h3 id="Global_attributes">Global attributes</h3>

<dl>
 <dt><a href="/docs/Web/SVG/Attribute/Core">Core Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('id')}}</small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Styling">Styling Attributes</a></dt>
 <dd><small>{{SVGAttr('class')}}, {{SVGAttr('style')}}</small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Conditional_Processing">Conditional Processing Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('requiredExtensions')}}, {{SVGAttr('systemLanguage')}}</small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Presentation">Presentation Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('clip-path')}}, {{SVGAttr('clip-rule')}}, {{SVGAttr('color')}}, {{SVGAttr('display')}}, {{SVGAttr('fill')}}, {{SVGAttr('fill-opacity')}}, {{SVGAttr('fill-rule')}}, {{SVGAttr('filter')}}, {{SVGAttr('mask')}}, {{SVGAttr('opacity')}}, {{SVGAttr('shape-rendering')}}, {{SVGAttr('stroke')}}, {{SVGAttr('stroke-dasharray')}}, {{SVGAttr('stroke-dashoffset')}}, {{SVGAttr('stroke-linecap')}}, {{SVGAttr('stroke-linejoin')}}, {{SVGAttr('stroke-miterlimit')}}, {{SVGAttr('stroke-opacity')}}, {{SVGAttr('stroke-width')}}, {{SVGAttr("transform")}}, {{SVGAttr('vector-effect')}}, {{SVGAttr('visibility')}}</small></dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>{{svginfo}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#ClipPathElement", "&lt;clipPath&gt;")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "masking.html#EstablishingANewClippingPath", "&lt;clipPath&gt;")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.clipPath")}}</p>

<h2 id="Related">Related</h2>

<ul>
 <li>Other clipping and masking SVG elements: {{SVGElement("mask")}}</li>
 <li>Some CSS properties: {{cssxref("clip-path")}}, {{cssxref("pointer-events")}}</li>
</ul>
